---
title:  Gyspy Software Development Kit
date:   Version 0.1.0, 2025-03-05
---


Using the SDK
=============

The Gypsy engine is provided as a shared C11 library and scripts which generate
source and data files.

Just a few steps are needed to setup a new project on Linux.

1. Unpack the SDK archive anywhere you like.
2. Copy the `Makefile` & `src` directory into your project.
3. Edit the `SDK` path at the top of the Makefile.
4. Type `make` to build the `game` binary.

> _**TODO:**_ Make the data.mod


Manual Setup
------------

What follows are example commands & arguments to use with your own build system
if you choose not to use the provided Makefile.

Set the SDK variables:

    export SDK=/opt/gypsy_sdk-0.1.0
    export BORON=${SDK}/bin/boron

Compile with SDK and game headers:

    -I${SDK}/include -Isrc

Link with SDK libarary:

    -L${SDK}/lib -lgypsy -lGL

Build the settings source:

    ${BORON} ${SDK}/tools/gen-settings.b src/app_settings.b >src/app_settings.c

Build the stages header:

    ${BORON} ${SDK}/tools/stage.b -i src/stages.c >src/stages.h

Build a data module:

    ${BORON} ${SDK}/tools/pack-gypsy.b data
