#ifndef ERROR_H
#define ERROR_H

// Exit status codes (sysexits.h)
#define EX_OK       0   /* successful termination */
#define EX_USAGE    64  /* command line usage error */
#define EX_DATAERR  65  /* data format error */
#define EX_NOINPUT  66  /* cannot open input */
#define EX_UNAVAILABLE  69  /* service unavailable */
#define EX_SOFTWARE 70  /* internal software error */
#define EX_OSERR    71  /* system error (e.g., can't fork) */
#define EX_CANTCREAT    73  /* can't create (user) output file */
#define EX_IOERR    74  /* input/output error */
#define EX_CONFIG   78  /* configuration error */

#if __GNUC__
#define PRINTF_LIKE(x,y)  __attribute__ ((format (printf, (x), (y))))
#else
#define PRINTF_LIKE(x,y) /* nothing */
#endif

#if defined(ANDROID) && defined(__cplusplus)
extern "C"
#endif
void errorFatal(int code, const char *fmt, ...) PRINTF_LIKE(2, 3);
void errorWarning(const char *fmt, ...) PRINTF_LIKE(1, 2);

#endif
