#ifndef EVENT_H
#define EVENT_H
/*
 * event.h
 */

#include <stdint.h>

enum InputEventType {
    IE_CYCLE_TIMER,
    IE_MSEC_TIMER,
    IE_FRAME_UPDATE,
    IE_KEY_PRESS,
    IE_KEY_RELEASE,
    IE_MOUSE_MOVE,
    IE_MOUSE_PRESS,
    IE_MOUSE_RELEASE,
    IE_MOUSE_WHEEL,
    IE_SCREEN_RESIZE,
    IE_WINDOW_FOCUS,
    IE_WINDOW_ICONIFY
};

enum InputEventModifier {
    IE_MOD_SHIFT = 1,
    IE_MOD_CTRL  = 2,
    IE_MOD_ALT   = 4,
    IE_MOD_CMD   = 8
};

enum MouseButton {
    IE_BUTTON_LEFT = 1,
    IE_BUTTON_MIDDLE,
    IE_BUTTON_RIGHT
};  

typedef union {
    uint16_t type;          // InputEventType
    struct {
        uint16_t type;
        uint16_t uid;       // HID Usage Id
        uint16_t modifier;  // InputEventModifier mask
        uint16_t unicode;
    } key;
    struct {
        uint16_t type;
        uint16_t button;
        uint16_t modifier;  // InputEventModifier mask
        int16_t  x;
        int16_t  y;
    } mouse;
    struct {
        uint16_t type;
        uint16_t enabled;
    } window;
} InputEvent;


#endif  // EVENT_H
