/*
  Gypsy Road - Game Browser
  Copyright (C) 2022-2024  Karl Robillard
  SPDX-License-Identifier: GPL-3.0-or-later
*/

#include "gui.h"

typedef struct {
    StringTable modi;
    uint8_t resPathI;
    uint8_t modFileI;
    uint8_t category;
    uint8_t parent;
} ModuleInfo;

typedef struct {
    ModuleInfo* data;
    uint32_t used, avail;
} ModuleInfoArray;

struct WorkBuffer;

enum GameBrowserWidgets {
    WI_LIST,
    WI_OK,
    WI_QUIT,
    WI_CANCEL,
    WI_COUNT
};

struct GameBrowser {
    StringTable modFiles;
    StringTable modFormat;
    ModuleInfoArray infoList;
    GuiState gui;
    uint16_t soundId[2];
    uint16_t fontId[3];
    uint16_t sel;
    uint16_t selMusic;          // 0 = none
    GuiArea gbox[ WI_COUNT ];
    struct WorkBuffer* work;
    ScrollPos listScroll;
    float lineHeight;
    float psizeList;            // List font point size.
    float descenderList;        // List font descender * point size.
    float itemHeightP;
    uint16_t slocGame;
    uint16_t slocSoundtrack;
};
typedef struct GameBrowser GameBrowser;
