#ifndef GYPSY_TYPES_H
#define GYPSY_TYPES_H

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// StringId and Symbol are similar, but symbol names do not allow whitespace.
typedef uint32_t StringId;
typedef uint16_t Symbol;

typedef uint32_t ClockMs;

typedef struct {
    uint16_t* data;
    size_t used, avail;
} U16Array;

void      array_u16_reserve(U16Array*, size_t len);
uint16_t* array_u16_append(U16Array*, size_t count);
void      array_u16_remove(U16Array*, size_t pos, size_t count);
int       array_u16_find(const U16Array*, uint16_t val);

#endif
