#ifndef SOUND_H
#define SOUND_H

#include <stdint.h>
#include <stdbool.h>

enum SoundPlayFlags {
    SOUND_ONCE      = 0x0001,
    SOUND_LOOP      = 0x0002,
    SOUND_FADE_IN   = 0x0010,
    SOUND_FADE_OUT  = 0x0020
};

#define MUSIC_NONE  -1

int  sound_init(int bufferLimit);
void sound_free(void);
void sound_suspend(int halt);

void sound_play(int soundId, int limitMSec);
void sound_speakLine(int streamId, int line, bool wait);

//int  sound_duration(Symbol name);
void sound_stop();
void sound_setVolume(float);
int  sound_volumeDec();
int  sound_volumeInc();

void music_play(int track, int flags);
void music_stop();
void music_fadeOut(int);
void music_fadeIn(int);
void music_setVolume(float);
int  music_volumeDec();
int  music_volumeInc();
bool music_toggle(int track);

#endif /* SOUND_H */
