#!/opt/gypsy_sdk-0.1.2/bin/boron -s
; Generate application settings specification data.

inspect: false
input: %src/app_settings.b

forall args [
	switch first args [
		"-i" [inspect: true]
		"-h" [print "Usage: settings.b [-i | -h | --version] [<settings>]" quit]
		"--version" [print "settings 0.2.1" quit]
		[input: to-file first args]
	]
]

cont: make block! 16
flat: make block! 64
def:  make block! 64
hbit: 1
hidden: 0
parse load input [some[
	tok: set-word! skip (
		append cont tok/1
		append/block cont tok/2
	)
  | skip
]]

enum-default: func [values] [
	either pos: find values '> [index?/zero pos] 0
]

add-param: func [name default range /extern hbit hidden] [
	if option? name [
		name: to-set-word name
		hidden: add hidden hbit
	]
	hbit: mul hbit 2

	appair flat name default
	either block? range [
		append/block def collect string! range
	][
		append def range
	]
]

map it cont [
	either block? it [
		start: tail flat
		parse it [some[
			tok: set-word!/option! [
				'enum block!       (add-param tok/1 enum-default tok/3 tok/3)
			  | word!              (add-param tok/1 eq? 'true tok/2 none)
			  | int!/coord! coord! (add-param tok/1 tok/2 tok/3)
			  | double! vec3!      (add-param tok/1 tok/2 tok/3)
			]
		]]
		slice start tail flat
	] it
]

context [
store: sdict: none
meld: func [data] [
	map it data [
		switch type? it [
			string! [
				ifn ss: pick sdict it [
					ss: tail store
					append store it
					poke sdict it ss: slice ss tail store
					append store '^0'
				]
				it: ss
			]
			block! [meld it]
		]
		it
	]
]

set 'meld-strings func [data /extern store sdict] [
	store: make string! 1024
	sdict: make hash-map! 256
	meld data
	sdict
]
]

meld-strings def
append/block flat mark-sol/block def
append flat to-hex hidden

either inspect [
	probe cont
	probe flat
][
	c-binary: func [file bin /local c] [
		prin rejoin [
			"// Generated by tools/settings.b^/"
			"^/static const unsigned char " file "_data[" size? bin "] = {"
		]
		n: 0
		foreach c bin [
			if zero? and 7 ++ n [prin "^/  "]
			prin to-hex c
			prin ','
		]
		prin "^/};^/"
	]

	c-binary 'settings serialize out: poke [settings: context none] 3 cont
	;save %/tmp/out out
]
